package blosum;

import java.util.Vector;
import java.util.StringTokenizer;
import blosum.utils.InputUtils;
import java.net.URL;

public class Matrixbla extends Matrix {

	StringTokenizer st;
	
	/**
	 * Method Matrixbla construct the matrix with the Blosum scores
	 * containing in the file fileName
	 *
	 * @param url
	 *
	 */
	public Matrixbla(URL url) throws Exception{
		super();
		Vector vet = new Vector();
		InputUtils.loadURL(url, vet);
		for(int i=7;i<vet.size();i++){
			int j = 0;
			st = new StringTokenizer((String)vet.elementAt(i));
			while (st.hasMoreTokens()) {
	        	this.setValue(i-7,j++,Float.parseFloat(st.nextToken()));

	        }
     	}
	}

  	/**
	 * Method getScore
	 *
	 *
	 * @param x an amino acid
	 * @param y an amino acid
	 *
	 * @return the Blosum score associated to the given amino acid pair (x,y)
	 *
	 */
	public float getScore(char x, char y) throws Exception{
    	int i = AminoAcid.indexOfAmin(x);
    	int j = AminoAcid.indexOfAmin(y);
    	if (i == 0 || j == 0) {
    		return 0;
    	}
		return this.getValue(i-1,j-1);
  }

}
