package blosum;

import java.util.Vector;
import java.util.StringTokenizer;
import blosum.utils.InputUtils;
import java.net.URL;

public class Matrixqij extends Matrix {
	
	private float[] marginal;	
	StringTokenizer st;
	
	/**
	 * Method Matrixqij construct the matrix with the likelihood
	 * of each couple of amino acid contained in the file specified by url
	 *
	 * @param url  
	 *
	 */
	public Matrixqij(URL url) throws Exception{
		super();
		Vector vet = new Vector();
		marginal = new float[20];
		for (int k = 0; k< marginal.length;k++) marginal[k] = 0;
		InputUtils.loadURL(url, vet);
		for(int i=4;i<vet.size();i++){
			int j = 0;
			st = new StringTokenizer((String)vet.elementAt(i));
			while (st.hasMoreTokens()) {
				float elem = Float.parseFloat(st.nextToken());
	        	setValue(i-4,j,elem);
	        	j++;
	        }
     	}
     	for(int i = 0; i<20; i++){     		
     		for(int j=0; j<20 ; j++){
     			if (i<j) marginal[i] = marginal[i] + this.getValue(j,i);
     			else marginal[i] = marginal[i] + this.getValue(i,j);
     		}
     	}
	}

	/**
	 * Method getMarginal
	 *
	 *
	 * @param x amino acid
	 *
	 * @return the number of occurrences of the amminoacid x.
	 *
	 */
	public float getMarginal(char x) throws Exception{
		return marginal[AminoAcid.indexOfAmin(x)-1];
	}

  /**
	 * Method getMarginal
	 *
	 *
	 * @param i index of an amino acid
	 *
	 * @return the marginal likelihood of the amino acid i.
	 *
	 */
	public float getMarginal(int i) {
		return marginal[i-1];
	}

  /**
	 * Method getProbability
	 *
	 *
	 * @param i index of an amino acid
     * @param j index of an amino acid
	 *
	 * @return the frequence of the amino acid pair (i,j)
	 *
	 */
	public float getProbability(int i, int j) {
		if (i<j) return this.getValue(j-1,i-1);
		else return this.getValue(i-1,j-1);
  }    
}

