package blosum.utils;

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class SequenceFastaFilter extends SequenceFilter{
	
	/**
	 * Method accept
	 *
	 * @param f  
	 *
	 * @return true if and only if the given file is accepted by this filter.
	 */
	public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String extension = this.getExtension(f);
        if (extension != null) {
            if (extension.equals("fasta")) {
                    return true;
            } else {
                return false;
            }
        }

        return false;
    }

    /**
	 * Method getDescription
	 *
	 * @return the description of this filter.
	 */
    public String getDescription() {
        return "fasta text document (*.fasta)";
    }
}
